<?xml version="1.0" encoding="UTF-8"?>

<xsl:transform version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:in="http://my.com/shipping"
>

  <xsl:output method="xml" />

  <xsl:template match="*" >
    <xsl:choose>
      <xsl:when test="namespace-uri () = 'http://tracking.org/messages' " >
        <xsl:element name="in:{local-name ()}" >
          <xsl:apply-templates select="*|@*|text ()" />
        </xsl:element>
      </xsl:when>
      <xsl:when test="local-name () = 'shipment'" >
        <xsl:copy>
          <xsl:apply-templates select="source" />
          <xsl:apply-templates select="destination" />
          <xsl:apply-templates select="requiresSignature" />
          <history>
            <xsl:for-each select="trackingNumber" > 
              <xsl:call-template name="CondenseTrackingNumber" />
            </xsl:for-each>
            <xsl:for-each select="history/trackingNumber" > 
              <xsl:text> </xsl:text>
              <xsl:call-template name="CondenseTrackingNumber" />
            </xsl:for-each>
          </history>
          <xsl:apply-templates select="batch" />
        </xsl:copy>
      </xsl:when>
      <xsl:when test="local-name () = 'trackingNumber'" >
        <xsl:copy>
          <xsl:call-template name="CondenseTrackingNumber" />
        </xsl:copy>
      </xsl:when>
      <xsl:otherwise>
        <xsl:copy><xsl:apply-templates select="*|@*|text ()" /></xsl:copy>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="@*|text ()" >
    <xsl:copy-of select="." />
  </xsl:template>
  
  <xsl:template name="CondenseTrackingNumber" >
    <xsl:value-of select="shipperID" />:<xsl:value-of select="shipmentNumber" />
  </xsl:template>
  
</xsl:transform>

